Index: /palm/trunk/SOURCE/lpm_advec.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_advec.f90	(revision 1928)
+++ /palm/trunk/SOURCE/lpm_advec.f90	(revision 1929)
@@ -1507,3 +1533,66 @@
     CALL cpu_log( log_point_s(44), 'lpm_advec', 'pause' )
 
+
  END SUBROUTINE lpm_advec
+
+! Description:
+! ------------
+!> Calculation of subgrid-scale particle speed using the stochastic model 
+!> of Weil et al. (2004, JAS, 61, 2877-2887).
+!------------------------------------------------------------------------------! 
+ SUBROUTINE weil_stochastic_eq( v_sgs, fs_n, e_n, dedxi_n, dedt_n, diss_n,     &
+                                dt_n, rg_n, fac )
+
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  c_0, sgs_wf_part
+
+    IMPLICIT NONE
+
+    REAL(wp) ::  a1      !< dummy argument
+    REAL(wp) ::  dedt_n  !< time derivative of TKE at particle position 
+    REAL(wp) ::  dedxi_n !< horizontal derivative of TKE at particle position
+    REAL(wp) ::  diss_n  !< dissipation at particle position 
+    REAL(wp) ::  dt_n    !< particle timestep
+    REAL(wp) ::  e_n     !< TKE at particle position
+    REAL(wp) ::  fac     !< flag to identify adjacent topography
+    REAL(wp) ::  fs_n    !< weighting factor to prevent that subgrid-scale particle speed becomes too large
+    REAL(wp) ::  sgs_w   !< constant (1/3)
+    REAL(wp) ::  rg_n    !< random number
+    REAL(wp) ::  term1   !< memory term
+    REAL(wp) ::  term2   !< drift correction term
+    REAL(wp) ::  term3   !< random term
+    REAL(wp) ::  v_sgs   !< subgrid-scale velocity component 
+
+!
+!-- Please note, terms 1 and 2 (drift and memory term, respectively) are 
+!-- multiplied by a flag to switch of both terms near topography. 
+!-- This is necessary, as both terms may cause a subgrid-scale velocity build up 
+!-- if particles are trapped in regions with very small TKE, e.g. in narrow street 
+!-- canyons resolved by only a few grid points. Hence, term 1 and term 2 are 
+!-- disabled if one of the adjacent grid points belongs to topography. 
+!-- Moreover, in this case, the  previous subgrid-scale component is also set
+!-- to zero.
+
+    a1 = fs_n * c_0 * diss_n
+!
+!-- Memory term
+    term1 = - a1 * v_sgs * dt_n / ( 4.0_wp * sgs_wf_part * e_n + 1E-20_wp )    &
+                 * fac
+!
+!-- Drift correction term
+    term2 = ( ( dedt_n * v_sgs / e_n ) + dedxi_n ) * 0.5_wp * dt_n              &
+                 * fac
+!
+!-- Random term
+    term3 = SQRT( MAX( a1, 1E-20 ) ) * ( rg_n - 1.0_wp ) * SQRT( dt_n )
+!
+!-- In cese one of the adjacent grid-boxes belongs to topograhy, the previous
+!-- subgrid-scale velocity component is set to zero, in order to prevent a 
+!-- velocity build-up. 
+
+!-- This case, set also previous subgrid-scale component to zero. 
+    v_sgs = v_sgs * fac + term1 + term2 + term3
+
+ END SUBROUTINE weil_stochastic_eq
Index: /palm/trunk/SOURCE/lpm_boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 1928)
+++ /palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 1929)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-!
+! Rewritten wall reflection 
 ! 
 ! Former revisions:
@@ -102,45 +102,61 @@
     CHARACTER (LEN=*) ::  range     !<
     
-    INTEGER(iwp) ::  i              !<
-    INTEGER(iwp) ::  inc            !<
-    INTEGER(iwp) ::  ir             !<
-    INTEGER(iwp) ::  i1             !<
-    INTEGER(iwp) ::  i2             !<
-    INTEGER(iwp) ::  i3             !<
-    INTEGER(iwp) ::  i5             !<
-    INTEGER(iwp) ::  j              !<
-    INTEGER(iwp) ::  jr             !<
-    INTEGER(iwp) ::  j1             !<
-    INTEGER(iwp) ::  j2             !<
-    INTEGER(iwp) ::  j3             !<
-    INTEGER(iwp) ::  j5             !<
-    INTEGER(iwp) ::  k              !<
-    INTEGER(iwp) ::  k1             !<
-    INTEGER(iwp) ::  k2             !<
-    INTEGER(iwp) ::  k3             !<
-    INTEGER(iwp) ::  k5             !<
-    INTEGER(iwp) ::  n              !<
-    INTEGER(iwp) ::  t_index        !<
-    INTEGER(iwp) ::  t_index_number !<
+    INTEGER(iwp) ::  inc            !< dummy for sorting algorithmus
+    INTEGER(iwp) ::  ir             !< dummy for sorting algorithmus
+    INTEGER(iwp) ::  i1             !< grid index (x) of old particle position
+    INTEGER(iwp) ::  i2             !< grid index (x) of current particle position
+    INTEGER(iwp) ::  i3             !< grid index (x) of intermediate particle position
+    INTEGER(iwp) ::  jr             !< dummy for sorting algorithmus
+    INTEGER(iwp) ::  j1             !< grid index (y) of old particle position
+    INTEGER(iwp) ::  j2             !< grid index (x) of current particle position
+    INTEGER(iwp) ::  j3             !< grid index (x) of intermediate particle position
+    INTEGER(iwp) ::  n              !< particle number
+    INTEGER(iwp) ::  t_index        !< running index for intermediate particle timesteps in reflection algorithmus
+    INTEGER(iwp) ::  t_index_number !< number of intermediate particle timesteps in reflection algorithmus
+    INTEGER(iwp) ::  tmp_x          !< dummy for sorting algorithmus
+    INTEGER(iwp) ::  tmp_y          !< dummy for sorting algorithmus
+
+    INTEGER(iwp), DIMENSION(0:10) :: x_ind(0:10) = 0 !< index array (x) of intermediate particle positions 
+    INTEGER(iwp), DIMENSION(0:10) :: y_ind(0:10) = 0 !< index array (x) of intermediate particle positions 
     
-    LOGICAL  ::  reflect_x   !<
-    LOGICAL  ::  reflect_y   !<
-    LOGICAL  ::  reflect_z   !<
-
-    REAL(wp) ::  dt_particle !<
-    REAL(wp) ::  pos_x       !<
-    REAL(wp) ::  pos_x_old   !<
-    REAL(wp) ::  pos_y       !<
-    REAL(wp) ::  pos_y_old   !<
-    REAL(wp) ::  pos_z       !<
-    REAL(wp) ::  pos_z_old   !<
-    REAL(wp) ::  prt_x       !<
-    REAL(wp) ::  prt_y       !<
-    REAL(wp) ::  prt_z       !<
-    REAL(wp) ::  t(1:200)    !<
-    REAL(wp) ::  tmp_t       !<
-    REAL(wp) ::  xline       !<
-    REAL(wp) ::  yline       !<
-    REAL(wp) ::  zline       !<
+    LOGICAL  ::  cross_wall_x    !< flag to check if particle reflection along x is necessary
+    LOGICAL  ::  cross_wall_y    !< flag to check if particle reflection along y is necessary
+    LOGICAL  ::  downwards       !< flag to check if particle reflection along z is necessary (only if particle move downwards)
+    LOGICAL  ::  reflect_x       !< flag to check if particle is already reflected along x
+    LOGICAL  ::  reflect_y       !< flag to check if particle is already reflected along y
+    LOGICAL  ::  reflect_z       !< flag to check if particle is already reflected along z
+    LOGICAL  ::  tmp_reach_x     !< dummy for sorting algorithmus
+    LOGICAL  ::  tmp_reach_y     !< dummy for sorting algorithmus
+    LOGICAL  ::  tmp_reach_z     !< dummy for sorting algorithmus
+    LOGICAL  ::  x_wall_reached  !< flag to check if particle has already reached wall
+    LOGICAL  ::  y_wall_reached  !< flag to check if particle has already reached wall
+
+    LOGICAL, DIMENSION(0:10) ::  reach_x  !< flag to check if particle is at a yz-wall
+    LOGICAL, DIMENSION(0:10) ::  reach_y  !< flag to check if particle is at a xz-wall
+    LOGICAL, DIMENSION(0:10) ::  reach_z  !< flag to check if particle is at a xy-wall
+
+    REAL(wp) ::  dt_particle    !< particle timestep
+    REAL(wp) ::  dum            !< dummy argument
+    REAL(wp) ::  eps = 1E-10_wp !< security number to check if particle has reached a wall
+    REAL(wp) ::  pos_x          !< intermediate particle position (x)
+    REAL(wp) ::  pos_x_old      !< particle position (x) at previous particle timestep
+    REAL(wp) ::  pos_y          !< intermediate particle position (y)
+    REAL(wp) ::  pos_y_old      !< particle position (y) at previous particle timestep
+    REAL(wp) ::  pos_z          !< intermediate particle position (z)
+    REAL(wp) ::  pos_z_old      !< particle position (z) at previous particle timestep
+    REAL(wp) ::  prt_x          !< current particle position (x)
+    REAL(wp) ::  prt_y          !< current particle position (y)
+    REAL(wp) ::  prt_z          !< current particle position (z)
+    REAL(wp) ::  t_old          !< previous reflection time
+    REAL(wp) ::  tmp_t          !< dummy for sorting algorithmus
+    REAL(wp) ::  xwall          !< location of wall in x
+    REAL(wp) ::  ywall          !< location of wall in y
+    REAL(wp) ::  zwall1         !< location of wall in z (old grid box)
+    REAL(wp) ::  zwall2         !< location of wall in z (current grid box)
+    REAL(wp) ::  zwall3         !< location of wall in z (old y, current x)
+    REAL(wp) ::  zwall4         !< location of wall in z (current y, old x)
+
+    REAL(wp), DIMENSION(0:10) ::  t  !< reflection time
+
 
     IF ( range == 'bottom/top' )  THEN
